/*  Copyright (C) 2010  Faculdade de Ciências e Tecnologia
 *                      Universidade Nova de Lisboa
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package pt.unl.fct.di.jtraceview.util;

import java.io.File;
import java.util.ArrayList;

import pt.unl.fct.di.jtraceview.trace.Event;
import pt.unl.fct.di.jtraceview.trace.TraceFileReader;
import pt.unl.fct.di.jtraceview.trace.events.TxCommitEvent;
import pt.unl.fct.di.jtraceview.trace.events.TxWriteEvent;

public class EventProcessingUtil {
	
	private static TraceFileReader reader;
	
	public static ArrayList<TxWriteEvent> getConflits(File traceFile,long start, long abortedOp, String memCell){
		
		ArrayList<TxWriteEvent> result = new ArrayList<TxWriteEvent>();		
		reader = new TraceFileReader(traceFile);
		reader.restoreSavePoint(start);
		long timestamp = reader.getNextEvent().timestamp;
		
		reader.restoreSavePoint(abortedOp);
		Event e = reader.getPreviousEvent();
		while(e.timestamp > timestamp){
			if(e instanceof TxCommitEvent){
				int threadId = e.threadId;
				long savePoint = reader.setSavePoint();
				Event event = reader.getPreviousEvent();
				while(event.timestamp > timestamp){
					if(event.threadId == threadId && event instanceof TxWriteEvent){
						TxWriteEvent writevent = (TxWriteEvent)event;
						if( memCell.equalsIgnoreCase(writevent.memCel)){
							result.add(writevent);
							break;
						}
					}
				}
				reader.restoreSavePoint(savePoint);
			}
			e = reader.getPreviousEvent();
		}
		return result;
	}
	public static TxWriteEvent getAborter(File traceFile,long start, long abortedOp, String memCell){
				
		reader = new TraceFileReader(traceFile);
		reader.restoreSavePoint(start);
		long timestamp = reader.getNextEvent().timestamp;
		
		reader.restoreSavePoint(abortedOp);
		Event e = reader.getPreviousEvent();
		while(e.timestamp > timestamp){
			if(e instanceof TxCommitEvent){
				int threadId = e.threadId;
				long savePoint = reader.setSavePoint();
				Event event = reader.getPreviousEvent();
				while(event.timestamp > timestamp){
					if(event.threadId == threadId && event instanceof TxWriteEvent){
						TxWriteEvent writevent = (TxWriteEvent)event;
						if( memCell.equalsIgnoreCase(writevent.memCel))
							return writevent;
					}
				}
				reader.restoreSavePoint(savePoint);
			}
			e = reader.getPreviousEvent();
		}
		return null;
	}
}
