/*  Copyright (C) 2010  Faculdade de Ciências e Tecnologia
 *                      Universidade Nova de Lisboa
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package pt.unl.fct.di.jtraceview.view.tools;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JPanel;

import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;

import com.jgoodies.forms.builder.DefaultFormBuilder;
import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.RowSpec;

/*
 * @author Ricardo Marques
 * @author Ricardo Dias
 */
@SuppressWarnings("serial")
public class ChartsViewerPanel extends JPanel { 
	
	private List<JFreeChart> chartList = null;
	
	public void setChart(JFreeChart chart) {
		List<ChartPanel> chartPanelList = new ArrayList<ChartPanel>(1);
		chartPanelList.add(new ChartPanel(chart));
		clear();
		drawCharts(chartPanelList);
		//MainForm.getMainForm().pack();
		setVisible(true);
	}

	public void setCharts(List<JFreeChart> charts) {
		chartList = charts;
		List<ChartPanel> chartPanelList = new ArrayList<ChartPanel>(charts.size());
		for (JFreeChart chart : charts) {			
			chartPanelList.add(new ChartPanel(chart));
		}		
		clear();
		drawCharts(chartPanelList);
		//MainForm.getMainForm().pack();
		setVisible(true);
	}

	private void clear() {		
		removeAll();
		//MainForm.getMainForm().pack();
		setVisible(false);
	}

	private void drawCharts(List<ChartPanel> chartPanelList) {
		FormLayout formLayout = new FormLayout( new ColumnSpec[] {
				FormFactory.GROWING_BUTTON_COLSPEC,
				FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
				FormFactory.PREF_COLSPEC},
				new RowSpec[0]);
		DefaultFormBuilder formBuilder = new DefaultFormBuilder(formLayout, this);
		for (int i=0; i<chartPanelList.size(); i++) {
			formBuilder.append(chartPanelList.get(i));			
			formBuilder.nextLine();
		}
	}

	public List<JFreeChart> getChartList() {
		return chartList;
	}
	
	
}
