/*  Copyright (C) 2010  Faculdade de Ciências e Tecnologia
 *                      Universidade Nova de Lisboa
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package pt.unl.fct.di.jtraceview.view.tools.component;

import java.util.ArrayList;
import java.util.List;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.EventListenerList;

public class DefaultJThreadSequenceModel implements JThreadSequenceModel {

	private List<Thread> threads;
	protected EventListenerList listenerList;
	
	public DefaultJThreadSequenceModel() {
		threads = new ArrayList<Thread>();
		listenerList = new EventListenerList();
		
		//initTestData();
	}
	
//	private void initTestData() {
//		Thread t = new Thread("Thread 1");
//		t.addTimeSlice(new TimeSlice("x", 0, 10));
//		t.addTimeSlice(new TimeSlice("z", 15, 45));
//		t.addTimeSlice(new TimeSlice("y", 50, 65));
//		t.addTimeSlice(new TimeSlice("x", 90, 130));
//		
//		threads.add(t);
//		
//		t = new Thread("Thread 2");
//		t.addTimeSlice(new TimeSlice("y", 5, 20));
//		t.addTimeSlice(new TimeSlice("y", 45, 50));
//		t.addTimeSlice(new TimeSlice("z", 60, 100));
//		t.addTimeSlice(new TimeSlice("x", 110, 130));
//		
//		threads.add(t);
//		
//	}

	@Override
	public void addThread(Thread t) {
		threads.add(t);
		
	}

	@Override
	public List<Thread> getThreads() {
		return threads;
	}

	@Override
	public int getThreadCount() {
		return threads.size();
	}

	@Override
	public void addChangeListener(ChangeListener listener) {
		listenerList.add(ChangeListener.class, listener);
	}
	
	@Override
	public void removeChangeListener(ChangeListener listener) {
		listenerList.remove(ChangeListener.class, listener);
	}
	
	/**
	 * Runs each <code>ChangeListener</code>'s <code>stateChanged</code>
	 * method.
	 */
	protected void fireStateChanged() {
		ChangeEvent event = new ChangeEvent(this);
		Object[] listeners = listenerList.getListenerList();
		for (int i = listeners.length - 2; i >= 0; i -= 2) {
			if (listeners[i] == ChangeListener.class) {
				((ChangeListener) listeners[i + 1]).stateChanged(event);
			}
		}
	}
	
	/**
	 * Returns an array of all the change listeners registered on this
	 * <code>DefaultBoundedRangeModel</code>.
	 * 
	 * @return all of this model's <code>ChangeListener</code>s or an empty
	 *         array if no change listeners are currently registered
	 * 
	 * @see #addChangeListener
	 * @see #removeChangeListener
	 */
	public ChangeListener[] getChangeListeners() {
		return (ChangeListener[]) listenerList
				.getListeners(ChangeListener.class);
	}

}
